/**
 * @author Mark Larkin, Conway Institute, UCD. mark.larkin@ucd.ie 
 *
 * Changes:
 *
 * 16-01-07,Nigel Brown(EMBL): Copied and modified from HistogramWidget to
 * subclass from Q3ScrollView instead of QWidget. This class replaces
 * HistogramWidget on Mac OS X to work around scrolling limitation in Qt4
 * QScrollArea. THIS CLASS SHOULD BE REMOVED WHEN QT4 QSCROLLAREA IS FIXED!
 *
 * 22-01-07,Nigel Brown(EMBL): replaced sizeHint() since default widget height
 * was too high.
 *
 * 20-02-07,Nigel Brown(EMBL): constructor and updateBoxSize() parameters
 * reordered.
 *
 * 12-4-07, Mark Larkin : Changed destructor. We dont need to delete QObjects. 
 *
 * 16-04-07,Nigel Brown(EMBL): removed destructor; arrayOfHeights not
 * allocated here.
 ****************************************************************************/

#ifndef HISTOGRAMWIDGETSCROLL_H
#define HISTOGRAMWIDGETSCROLL_H

#include <QFont>
class QImage;
//class QPixmap;
#include <QPixmap> // Mark 20-4-2007
class QPoint;
class QSize;
class QString;
//class QWidget;
#include <Q3ScrollView>
#include <vector>
#include <QLabel>

/**
 * The HistogramWidgetScroll class displays a graphical histogram. It also displays a ruler.
 */
class HistogramWidgetScroll : public Q3ScrollView  //nige
{
    Q_OBJECT

public:
    HistogramWidgetScroll(int boxWidth, int boxSize);  //nige
    void setHorizontalScrollBarPolicy(Qt::ScrollBarPolicy policy);
    void setVerticalScrollBarPolicy(Qt::ScrollBarPolicy policy);
    QSize sizeHint() const;
    void addHistogramInfo(std::vector<int>* histogramValues);
    void clearHistogram();
    const std::vector<int>* getColumnScores(){return arrayOfHeights;}
public slots:
    void updateBoxSize(int boxWidth, int boxSize);
    void updateSizeHint();
signals:
    void characterSelected(const QString &character);

protected:
    //void paintEvent(QPaintEvent *event); DISABLED,nige
    void drawContents(QPainter *p, int cx, int cy, int cw, int ch); //nige
    //void HistogramWidgetScroll::contentsMousePressEvent(QMouseEvent *event);  //nige test

private:
    void calculateHistogramBars();
    QFont rulerFont;
    int alignLength; 
    int heightAllowed;
    int boxSize;
    int boxWidth;
    float heightOfBox;
    std::vector<int>* arrayOfHeights;
    QVector<QPixmap> histogramBars;  
    int displayStartPos;
    int offSetFromTop;
    int extraWhiteSpace;
    QColor *rulerColor;
    int lengthSmallBar;
    int lengthLargeBar;
    bool isSet;
};

#endif
